# -*- coding: utf-8 -*-
"""
Created on Fri Dec  6 11:55:53 2019

@author: zzzxq
"""

import numpy as np
import matplotlib.pyplot as plt
import scipy.stats as stats
from scipy.stats import chi2

###(i)
L= 2030302010666%67 + 10  ##学号为虚构
print(L)

###(ii)
mu=0
sigma=1
normal_samp=[np.random.normal(mu,sigma,L) for i in range(1000)]

###(iii)
z = []
for i in range(1000):
    sum = 0
    list1 = list(normal_samp[i])
    for j in range(L):
        sum = sum + list1[j] ** 2
    z.append(sum)
    
###(iv)
num_bins = 50 
plt.hist(z, num_bins,facecolor='blue', alpha=0.5,density=True)
plt.plot(np.linspace(0,100,1000),stats.chi2.pdf(np.linspace(0,100,1000),df=L),color = 'red')#绘制0到100的卡方分布曲线,给定自由度为L
plt.xlabel('z')
plt.ylabel('density')
plt.title('Histgram & Chi-square distribution' )
plt.show()

###(v)
z_mean = np.mean(z)
z_var = np.var(z)
z_skew = stats.skew(z)
z_kur = stats.kurtosis(z)
print('z的样本均值为：', z_mean)
print('z的样本方差为：', z_var)
print('z的样本偏度为：', z_skew)
print('z的样本峰度为：', z_kur)
#求卡方分布的总体均值、方差、偏度与峰度
df = L 
mean,var,skew,kur =  chi2.stats(df,moments='mvsk')
print('自由度为',df,'的卡方分布总体均值为：',mean)
print('自由度为',df,'的卡方分布总体方差为：',var)
print('自由度为',df,'的卡方分布总体偏度为：',skew)
print('自由度为',df,'的卡方分布总体峰度为：',kur)

###(vi)
num_bins = 50 
plt.hist(z, num_bins,facecolor='blue', alpha=0.5,density=True)
norm_mu = np.mean(z)
norm_std = np.std(z)
plt.plot(np.linspace(0,100,1000),stats.norm.pdf(np.linspace(0,100,1000),norm_mu,norm_std))
plt.xlabel('z')
plt.ylabel('density')
plt.title('Histgram & Normal distribution' )
plt.show()
